/////////////////////////////////////////////////////////////////
//Copyright (C) 2005 NTT CORPORATION.
//
//	アサイン更新処理　アサイン画面のグループツリー表示Actionクラス
//
//		変更履歴
//			2005.02.16  新規作成  氏名 石崎賢太郎
//
//	機能
//
//	アサイン画面のグループツリー表示Actionクラスです。
//
/////////////////////////////////////////////////////////////////
package jp.co.ntt.lms.xmf.actions.lo.method.methodassignments;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import jp.co.ntt.lms.xmo.Groups.GroupsClient;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.util.MessageResources;

/**
 * アサイン画面のグループツリー表示Actionクラスです。
 * 
 * @author Kentaro Ishizaki (UNITEC)
 * @version 1.0
 */
public class MethodAssignmentsFrameUserOrGroupAction extends Action
{
	/**
	 * strutsフレームワークから呼ばれるメソッドです。
	 * 
	 * @param mapping マッピングオブジェクト。
	 * @param form アクションフォームオブジェクト。
	 * @param request リクエストオブジェクト。
	 * @param response レスポンスオブジェクト。
	 * @return ActionForward アクションフォワードオブジェクト。
	 * @throws Exception
	 */
	public ActionForward execute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception
	{
		String strGroupRootName_o = "";//グループルート名

		String strLoginUserID = (String)request.getSession().getAttribute(MethodAssignmentsConstants.USER_ID);

		// メッセージリソース取得
		MessageResources resources = getResources(request, "msg.xmf.lo.Method.MethodAssignments.MessageResources");
		
		// ログインユーザがスーパーユーザか普通の管理者かでルートのIDを切り分けます。
		String strTreeRoot_o = null;
		if( strLoginUserID == null ) {
			// セッションが切れている場合はログイン画面にリダイレクト
			request.setAttribute("message", "");
			request.setAttribute("detail", "");
			request.setAttribute("close", "on");
			request.setAttribute("errorurl", MethodAssignmentsConstants.LOGIN_REDIRECT);
			return mapping.findForward("error");
		}
		else {
			// ログインユーザがスーパーユーザの場合
			if( strLoginUserID.equals(MethodAssignmentsConstants.SUPER_USER) ) {
				strTreeRoot_o = MethodAssignmentsConstants.GROUP_ROOT_o;
				//////////////////////////////////////////////////
				//グループのルート名ををデータベースから取得する。
				//////////////////////////////////////////////////
				GroupsClient objGroups = new GroupsClient();
				// 検索条件の設定
				objGroups.setWhereGroupID( MethodAssignmentsConstants.GROUP_ROOT_o );
				if( !objGroups.select() ) {
					// 検索がうまくいかなかった場合
					if( objGroups.isErr() ) {
						// エラーの場合
						request.setAttribute("message", "");
						request.setAttribute("detail", "");
						request.setAttribute("close", "on");
						request.setAttribute("errorurl", objGroups.getURL());
						return mapping.findForward("error");
					}
					else {
						String strMessage =  objGroups.getMessage();
						request.setAttribute("message", strMessage);
						request.setAttribute("detail", "");
						request.setAttribute("close", "on");
						request.setAttribute("errorurl", "");
						return mapping.findForward("error");
					}
				}

				// グループ名の取得
				if( objGroups.next() ) {
					strGroupRootName_o = objGroups.getGroupName();
				}
				else {
					//グループ名が存在しない場合エラーを出力する
					String strMessage = resources.getMessage("M022007");
					request.setAttribute("message", strMessage);
					request.setAttribute("detail", "");
					request.setAttribute("close", "on");
					request.setAttribute("errorurl", "");
					return mapping.findForward("error");
				}

			}
			else {
				strTreeRoot_o = MethodAssignmentsConstants.GROUP_TREE_ROOT;
				strGroupRootName_o = MethodAssignmentsConstants.TREE_ROOT_NAME;
			}
		}

		// ツリーデータ取得用のアプレット
		String strServerName_o = request.getServerName();
		int intServerPort_o = request.getServerPort();
		String strContextPath_o = request.getContextPath();
		
		
		// リクエストに変数をセット
		request.setAttribute("strServerName_o", strServerName_o);
		request.setAttribute("intServerPort_o", new Integer(intServerPort_o));
		request.setAttribute("strContextPath_o", strContextPath_o);
		// 
		request.setAttribute("strTreeRoot_o", strTreeRoot_o);
		request.setAttribute("strGroupRootName_o", strGroupRootName_o);
		
		return mapping.findForward("success");
	}

}
